in(1, 1).
facing(north).

start :- go.

go :- in(X, Y),
      filth_sensor <- isDirty(X, Y) returns true,
      cleaner <- clean(X, Y),
      facing(D),
      not(border_sensor <- at_borders(X, Y) returns true), !, move(X, Y, D), go.
go :- in(X, Y),
      filth_sensor <- isDirty(X, Y) returns false,
      facing(D),
      not(border_sensor <- at_borders(X, Y) returns true), !, move(X, Y, D), go.
go :- in(X, Y), border_sensor <- at_borders(X, Y) returns true.

move(X, Y, north) :-
  border_sensor <- maxX returns Mx, border_sensor <- maxY returns My,
  X < Mx, Y =< My, NewX is X + 1,
  retract(in(X, Y)), !, assert(in(NewX, Y)), !.
move(X, Y, north) :-
  border_sensor <- maxX returns Mx, border_sensor <- maxY returns My,
  X = Mx, Y < My,
  retract(facing(_)), !, assert(facing(east)), !,
  NewY is Y + 1,
  retract(in(X, Y)), !, assert(in(X, NewY)), !.
move(X, Y, east) :-
  border_sensor <- maxY returns My,
  X > 0, Y =< My,
  retract(facing(_)), !, assert(facing(south)), !,
  NewX is X - 1,
  retract(in(X, Y)), !, assert(in(NewX, Y)), !.
move(X, Y, south) :-
  border_sensor <- maxY returns My,
  X > 0, Y =< My, NewX is X - 1,
  retract(in(X, Y)), !, assert(in(NewX, Y)), !.
move(X, Y, south) :-
  border_sensor <- maxY returns My,
  X = 0, Y < My,
  retract(facing(_)), !, assert(facing(west)), !,
  NewY is Y + 1,
  retract(in(X, Y)), !, assert(in(X, NewY)), !.
move(X, Y, west) :-
  border_sensor <- maxX returns Mx, border_sensor <- maxY returns My,
  X < Mx, Y =< My,
  retract(facing(_)), !, assert(facing(north)), !,
  NewX is X + 1,
  retract(in(X, Y)), !, assert(in(NewX, Y)), !.