import alice.tuprolog.Number;
import alice.tuprolog.Prolog;
import alice.tuprolog.SolveInfo;

public class TemperatureSensor {
    Prolog environment;
    public TemperatureSensor(Prolog environment) {
        this.environment = environment;
    }
    public int getTemperature() throws Exception {
        SolveInfo query = environment.solve("temp(X).");
        if (query.isSuccess()) {
            Number temperature = (Number) query.getTerm("X");
            return temperature.intValue();
        } else
            return -273;
    }
}
